$.ajaxSetup({xhr: function() {return new window.XMLHttpRequest();}});

function jsescape(str) {str = str.split("\\").join("\\\\"); str = str.split("'").join("\\'"); str = str.split("\"").join("\\\""); str = str.split("\n").join("\\n"); return str;}
function htmlescape(str) {str = str.replace(/&/g, '&amp;'); str = str.replace(/</g, '&lt;'); str = str.replace(/>/g, '&gt;'); return str;}

$.fn.lightbox = function(options) {
	options = $.extend({}, options);
	if(!$.lightbox_handler) $.lightbox_handler = new LightboxHandler(options);
	$.lightbox_handler.show(this, options.callback, options);
	return this;
}
$.fn.centerbox = function(selector, options) {
	options = $.extend({}, options);
	var $this = $(this);
	var p = $this.parents(selector).eq(0);
	$this.css({left:(p.outerWidth()-$this.outerWidth())/2, top:(p.outerHeight()-$this.outerHeight())/2});
	if(options.callback) options.callback.call();
	return this;
}
$.fn.animateCenter = function(selector, options) {
	options = $.extend({}, options);
	var $this = $(this);
	var p = $this.parents(selector).eq(0);
	$this.animate({left:(p.outerWidth()-$this.outerWidth())/2, top:(p.outerHeight()-$this.outerHeight())/2}, options);
	return this;
}
$.fn.equals = function(compareTo) {
	if(!compareTo || this.length != compareTo.length) return false;
	for(var i = 0; i < this.length; ++i) {
		if(this[i] !== compareTo[i]) return false;
	}
	return true;
};
LightboxHandler = function(options) {
	if(!options) options = {};
	this.options = options = $.extend({
		fade: "fast",
		size: "fast",
		backgroundColor: 'black',
		backgroundOpacity: 0.75,
		foregroundColor: 'white',
		foregroundClass: 'fgbox',
		loadingContents: ''
	}, options);
	var $this = this;
	$.lightbox_handler = this;
	$('<div id="lightbox_offscreen"/><div id="lightbox_staging"/><div id="lightbox_container"><div id="lightbox_background"/><div id="lightbox_foreground"><div id="lightbox_loading"/><div id="lightbox_contents"/></div></div>').appendTo($('body'));

	$('#lightbox_container').css({
		position: 'fixed',
		zIndex: 250,
		left: 0,
		top: 0,
		display: 'none'
	});
	$('#lightbox_background').css({
		position: 'fixed',
		width:'100%',
		height:'100%',
		left: 0,
		top: 0,
		background: options.backgroundColor,
		opacity:options.backgroundOpacity
	}).click(function(){$this.close()});
	$('#lightbox_offscreen').hide();
	$('#lightbox_staging').css({
		position: 'absolute',
		visibility: 'hidden',
		left: -20000,
		top: -20000
	});
	$('#lightbox_foreground').css({
		background: options.foregroundColor,
		position: 'absolute'
	}).addClass(options.foregroundClass);
	$('#lightbox_contents').css({
		background: options.foregroundColor,
		position: 'absolute',
		width: 'auto',
		height: 'auto'
	});
	$('#lightbox_loading').css({position: 'absolute'});

	$(window).resize(function(){$this.resized()});
	this.show = function(content, callback, params) {
		if(!params) params = {};
		this.options.ok = params.ok;
		this.options.onclose = params.onclose;
		this.options.onbeforeclose = params.onbeforeclose;
		if(this.is_open && !this.closing) this.change(content, callback);
		else this.open(content, callback);
	}
	this.open = function(content, callback) {
		if(this.closing) {
			var $this = this;
			this.closing = false;
			$('#lightbox_container').fadeIn("fast", function(){$this.change(content, callback);});
			return;
		}
		$('#lightbox_container').css({visibility:'hidden',display:'block'});
		this.setContents(content);
		this.setSize();
		this.resized();
		this.is_open = true;
		$('#lightbox_loading').centerbox();
		$('#lightbox_container').css({display:'none',visibility:'visible'});
		$('#lightbox_container').fadeIn(this.options.fade, callback);
	};
	this.stop = function() {
		$('#lightbox_container').stop(true,true);
		$('#lightbox_foreground').stop(true,true);
		$('#lightbox_contents').stop(true,true);
	}
	this.ok = function() {
		if(this.options.ok) this.options.ok.call($('#lightbox_contents').contents().eq(0));
		this.close();
	}
	this.close = function() {
		if(this.options.onbeforeclose && !this.options.onbeforeclose.call($('#lightbox_contents').contents().eq(0))) return;
		this.closing = true;
		this.stop();
		var $this = this;
		$('#lightbox_container').fadeOut("fast",function(){$this.closed()});
	};
	this.closed = function() {
		this.closing = false;
		this.is_open = false;
		var old = $('#lightbox_contents').contents().eq(0);
		$('#lightbox_offscreen').append($('#lightbox_contents').contents().detach());
		if(this.options.onclose) this.options.onclose.call(old);
		this.options.onclose = undefined;
	};
	this.resized = function() {
		this.stop();
		var a = $.pagesize();
		$('#lightbox_container').width(a[2]).height(a[3]);
		var fg = $('#lightbox_foreground');
		var fw = fg.outerWidth(), fh = fg.outerHeight();
		fg.css({left:(a[2]-fw)/2, top:(a[3]-fh)/2});
	};
	this.setContents = function(content, hidden) {
		content = $(content).show();
		var ct = $('#lightbox_contents');
                $('#lightbox_offscreen').append(ct.contents().detach());
		if(hidden) ct.css('opacity',0);
		ct.append(content);
		var fg = $('#lightbox_foreground');
		var fw = fg.outerWidth(), fh = fg.outerHeight();
		var cw = ct.outerWidth(), ch = ct.outerHeight();
		ct.css({left:(fw-cw)/2, top:(fh-ch)/2});
	}
	this.currentContents = function() {
		return $('#lightbox_contents').contents();
	}
	this.fadeContents = function(opacity, callback) {
		if(!opacity) $('#lightbox_loading').centerbox().show();
		$('#lightbox_contents').animate({opacity:opacity}, {duration:"fast", complete:function(){if(opacity)$('#lightbox_loading').hide();if(callback)callback.call()}});
	}
	this.change = function(content, callback) {
		if(this.changing) {
			if(!this.changeQueue) this.changeQueue = [];
			this.changeQueue.push([content,callback]);
			return;
		}
		content = content ? $(content) : this.currentContents();
		if(content.equals(this.currentContents())) {if(callback) callback.call(); return;}
		this.changing = true;
		var fg = $('#lightbox_foreground');
		var $this = this;
		$this.expandTo(content, function(){
			$this.fadeContents(0, function(){
				$this.setContents(content, true);
				$this.fadeContents(1, function(){
					$this.sizeTo(content, function(){
						if(callback) callback.call();
						$this.nextChange();
					});
				});
			});
		});
	};
	this.nextChange = function() {
		this.changing = false;
		if(!this.changeQueue) return;
		var next = this.changeQueue.shift();
		if(!this.changeQueue.length) this.changeQueue = undefined;
		this.change.apply(this, next);
	}
	this.expandTo = function(content, callback) {
		content = content ? $(content) : this.currentContents();
		$('#lightbox_loading').centerbox();
		var fg = $('#lightbox_foreground');
		var ct = $('#lightbox_contents');
		var fw = fg.outerWidth(), fh = fg.outerHeight();
		if(!content.equals(this.currentContents())) {
			$('#lightbox_staging').append(content.detach());
			content.show();
		}
		var w=content.outerWidth(), h=content.outerHeight();
		$('#lightbox_offscreen').append($('#lightbox_staging').contents().detach());
		var cw = ct.outerWidth(), ch = ct.outerHeight();
		if(w<=fw && h<=fh) {if(callback) callback.call(); return;}
		if(w<=fw) w=fw;
		if(h<=fh) h=fh;
		var page = $.pagesize();
		var x = (page[2]-w) / 2;
		var y = (page[3]-h) / 2;
		fg.animate({width:w, height:h, left:x, top:y}, {duration:this.options.size, complete:callback});
		ct.animate({left:(w-cw)/2, top:(h-ch)/2}, {duration:this.options.size, complete:callback});
	};
	this.sizeTo = function(content, callback) {
		content = content ? $(content) : this.currentContents();
		$('#lightbox_loading').centerbox();
		var fg = $('#lightbox_foreground');
		var ct = $('#lightbox_contents');
		var w=content.outerWidth(), h=content.outerHeight();
		var cw = ct.outerWidth(), ch = ct.outerHeight();
		var page = $.pagesize();
		var x = (page[2]-w) / 2;
		var y = (page[3]-h) / 2;
		fg.animate({width:w, height:h, left:x, top:y}, {duration:this.options.size, complete:callback});
		ct.animate({left:(w-cw)/2, top:(h-ch)/2}, {duration:this.options.size, complete:callback});
	};
	this.setSize = function() {
		var fg = $('#lightbox_foreground');
		var ct = $('#lightbox_contents');
		var w=ct.outerWidth(), h=ct.outerHeight();
		var page = $.pagesize();
		var x = (page[2]-w) / 2;
		var y = (page[3]-h) / 2;
		fg.css({width:w, height:h, left:x, top:y});
		ct.css({left:0, top:0});
	};
};
$.pagesize = function() {
	var xScroll, yScroll;
	if(window.innerHeight && window.scrollMaxY) {	
		xScroll = window.innerWidth + window.scrollMaxX;
		yScroll = window.innerHeight + window.scrollMaxY;
	} else if (document.body.scrollHeight > document.body.offsetHeight){ // all but Explorer Mac
		xScroll = document.body.scrollWidth;
		yScroll = document.body.scrollHeight;
	} else { // Explorer Mac...would also work in Explorer 6 Strict, Mozilla and Safari
		xScroll = document.body.offsetWidth;
		yScroll = document.body.offsetHeight;
	}
	var windowWidth, windowHeight;
	if(self.innerHeight) {	// all except Explorer
		if(document.documentElement.clientWidth) windowWidth = document.documentElement.clientWidth;
		else windowWidth = self.innerWidth;
		windowHeight = self.innerHeight;
	} else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
		windowWidth = document.documentElement.clientWidth;
		windowHeight = document.documentElement.clientHeight;
	} else if (document.body) { // other Explorers
		windowWidth = document.body.clientWidth;
		windowHeight = document.body.clientHeight;
	}	
	// for small pages with total height less then height of the viewport
	if(yScroll < windowHeight) pageHeight = windowHeight;
	else pageHeight = yScroll;
	// for small pages with total width less then width of the viewport
	if(xScroll < windowWidth) pageWidth = xScroll;
	else pageWidth = windowWidth;

	arrayPageSize = new Array(pageWidth,pageHeight,windowWidth,windowHeight);
	return arrayPageSize;
};

checklive = function() {
	if(typeof(live_games) == 'undefined') {
		$('#hub_live').text("Unable to retrieve live game list.");
	}
}

var about_only;

// Pager

var login_url = undefined;
var login_usermessage;
var login_destination;

var last_account='';
var current_key='';
var last_server='';
quickform = function(url, params) {
	var form=$('<form method="get" action="'+url+'"/>');
	if(!params) params = {};
	for(var key in params) {var input=$('<input type=hidden/>').attr('name',key).appendTo(form); input.val(params[key].toString());}
	$('body').append(form);
	form[0].submit();
	form.remove();
}

pagerlogin = function(url, refresh) {
	if(about_only) return;
	if(!url) url = last_server;
	if(typeof(login_url) == 'undefined') return;
	if(login_url && !login_url.match(/\/$/)) login_url += '/';
	login_destination = url;
	url = login_url + 'login.html?url=' + encodeURIComponent(url);
	if(login_usermessage) url += '&message=' + encodeURIComponent(login_usermessage);
	if(!login_url) url = 'login.html';
	try {
	if(!$('iframe#loginform').length) {
		$('#loginform').remove();
		$('<iframe id=loginform marginwidth=0 marginheight=0 frameborder=0 scrolling=no />').css('overflow','hidden').attr('src',url).lightbox({onclose:function(){$('#loginform').remove();}});
	}
	else {
		if(refresh) $('#loginform').attr('src',url);
		else lb = $('#loginform').lightbox({onclose:function(){$('#loginform').remove();}});
	}
	}
	catch(e) {}
}
pagerlogout = function(){quickform("pager://logout");}

var skin_version;

var about_desc = '';
var about_copyright = 'Copyright &copy; ' + (new Date()).getYear();
var about_title;
var about_version;

about = function() {
	$('#aboutpop').lightbox({onclose:function(){$('#popupiframe').remove();},onbeforeclose:function(){if(about_only)quickform('pager://close');return true;},callback:(about_only?function(){var pop=$('#aboutpop'); quickform('pager://aboutsize',{width:pop.width(),height:pop.height()});}:null)});
}
prefs = function(settings) {
	if(about_only) return;
	if(!settings) settings = {hwmode: true};
	for(var name in settings) $('#prefsform input[name='+name+']').attr('checked',settings[name]);
	$('#prefspop').lightbox({onclose:function(){$('#popupiframe').remove();}});
}
setaccount = function(key, as_default) {
	$('body').attr('scroll','no');
	if(key && as_default) last_account=key;
	if(!as_default) {
		current_key = key;
		if(subscription_poll_timer) {
			clearInterval(subscription_poll_timer);
			subscription_poll_timer = 0;
		}
		if(key) {
			$('#login').html("<a href=\"pager://edit_account?key="+encodeURIComponent(key)+"\" title=\"Manage your BYOND account\">" + htmlescape(key) + "</a> <span class=separator>|</span> <a class=prefs_link href=\"pager://prefs\">Preferences</a> <span class=separator>|</span> <a class=logout_link href=\"pager://logout\">Logout</a>");
			$('body').not('.logged_in').addClass('logged_in');
			if(key.match(/^Guest$/i)) subscription_results({});
			else subscription_status();
			try {user_login(key);} catch(e) {}
                }
		else {
			$('#login').html("<a class=prefs_link href=\"pager://prefs\">Preferences</a> <span class=separator>|</span> <a class=login_link href=\"#\" onclick=\"pagerlogin(); return false\">Login</a>");
			$('body').removeClass('logged_in');
			subscription_results({});
			try {user_logout();} catch(e) {}
                }
	}
}
toK = function(n,n2) {
	var u=0, unit='bytes';
	var units=['KB','MB','GB'];
	n = parseInt(n.toString(),10);
	while(units.length && n >= 1024) {n /= 1024; if(n2) n2 /= 1024; ++u; unit = units.shift();}
	if(n2 && n2 < 1024) return n.toFixed(1);
	return (u ? n.toFixed(1).toString() : n.toString()) + ' ' + unit;
}
progress = function(msg, pct) {
	if(!msg) $('#progress').hide();
	else {msg=msg.replace(/\((\d+)\/(\d+) bytes\)/,function(a,b,c){return '('+toK(b,c)+' of '+toK(c)+')'}); $('#progress').show(); $('#progressmessage').text(msg); $('#progressbar').css('width', pct + '%');}
}

subscription_status = function() {
	quickform('pager://subscription_status');
}
subscription_check = function(url, key, path) {
	try {
		url += "members/?command=subscription_status_ajax&key=" + encodeURIComponent(key) + "&hub=" + encodeURIComponent(path) + "&cb=subscription_results";
		url += '&time=' + (new Date()).getTime();
		$('script#subcheck').remove();
		var s = $('<script id=subcheck src=\"'+url+'\" type=text/javascript></script>');
		$('head').append(s);
	}
	catch(e) {}
}
subscription_results = function(results) {
	if(!results) results = {};
	$('#sub_time').text(results.time_left || '');
	if(results.subscribed && results.days_left < 0) {
		$('body').not('.subscriber').addClass('subscriber');
		$('body').removeClass('non_subscriber');
		$('body').not('.lifetime_subscriber').addClass('lifetime_subscriber');
		$('body').removeClass('finite_subscriber');
	}
	else if(results.subscribed) {
		$('body').not('.subscriber').addClass('subscriber');
		$('body').removeClass('non_subscriber');
		$('body').not('.finite_subscriber').addClass('finite_subscriber');
		$('body').removeClass('lifetime_subscriber');
	}
	else {
		if(results.key) $('body').not('.non_subscriber').addClass('non_subscriber');
		else $('body').removeClass('non_subscriber');
		$('body').removeClass('subscriber').removeClass('lifetime_subscriber').removeClass('finite_subscriber');
	}
	if(results.key) try {subscriber_info(results)} catch(e) {}
}
var subscription_poll_timer = 0;
var subscription_poll_delay = 30;
subscription_poll = function() {
	if(subscription_poll_timer) return;
	subscription_poll_timer = setInterval(subscription_status, subscription_poll_delay * 1000);
}

var frame_options;
iframepop = function(url, params) {
	if(!url && $('#popupiframe').length) {pagerlogin(); return;}
	if(!params) params = {};
	var page = $.pagesize();
	$('#popupiframe').remove();
	$('<iframe id="popupiframe" marginwidth=0 marginheight=0 frameborder=0 scrolling="no"/>').width((params.width||page[0])*(params.actual_size?1:0.8)).height((params.height||page[1])*(params.actual_size?1:0.9)).css('overflow','hidden').attr('src',url).lightbox({onclose:function(){$('#popupiframe').remove();},onbeforeclose:function(){pagerlogin();}});
}
closepop = function() {if($.lightbox_handler) $.lightbox_handler.close();}

settitle = function(msg) {
	if(!msg && typeof(live_games) != 'undefined' && live_games.hub && live_games.hub.name && !document.title) msg = live_games.hub.name;
	if(msg) document.title = msg;
}

fill_live = function() {
	if(poll_live_timer) clearTimeout(poll_live_timer);
	checklive();
	if(!$('#hub_live').length) return;
	var live_section = $('#hub_live').eq(0);
	var new_section = $('<div/>');
	new_section.append('<div class="title live_games'+(live_games.count?' none_live':'')+'">'+live_games.title+'</div>');
	for(var i=0; i<live_games.worlds.length; ++i) {
		var world = live_games.worlds[i];
		var world_div = $('<div class="world"/>').appendTo(new_section);
		var join = $('<a><span>Join</span></a>').attr('href', world.url);
		$('<div class="join"/>').append(join).appendTo(world_div);
		$('<div class="status"/>').html(world.status).appendTo(world_div);
		$('<div class="player_total">').text(world.players_title).appendTo(world_div);
		var players_div = $('<div class="players"/>').appendTo(world_div);
		var player_html = '';
		for(var j=0; j<world.players.length; ++j) {
			if(j) player_html += " ";
			player_html += "<span class=\"player\">"
			player_html += "<a href=\"[% page.members_url %]" + world.players[j].replace(/[\W_]/g,'') + "\">" + world.players[j] + "</a>";
			if(world.guests || j+1<world.players.length) player_html += ' &middot;';
			player_html += "</span>"
		}
		if(world.guests) {
			if(j) player_html += " ";
			player_html += "<span class=\"player private\">" + world.guests + " private</span>";
		}
		players_div.html(player_html);
	}
	live_section.html(new_section.html());
}

local = function(hubpath, url) {
	if(!$('#hub_local').length) return;
	var local_section = $('#hub_local').eq(0);
	var new_section = $('<div/>');
	var world_div = $('<div class="world"/>').appendTo(new_section);
	var join = $('<a><span>Join</span></a>').attr('href', 'pager://autologin?url='+encodeURIComponent(url));
	$('<div class="join"/>').append(join).appendTo(world_div);
	$('<div class="status"/>').html('Local game').appendTo(world_div);
	local_section.html(new_section.html());
}

setabouttitle = function(name) {
	$('#abouttitle').html(typeof(about_title) != 'undefined' ? about_title : ('About '+name));
}
setaboutversion = function(ver) {
	about_version = ver;
	$('#aboutversion').html('Version '+about_version);
}

var use_pager = true;
$(document).ready(function(){
	setaccount();
	$('#aboutdesc').html(about_desc);
	$('#aboutcopyright').html(about_copyright);
	if(typeof(about_title) != 'undefined') $('#abouttitle').html(about_title);
});

window.onerror = function (msg, url, line) {
	try {if(use_pager) quickform("pager://error", {message: msg, url: url, line: line});}
	catch(e) {}
	return true;
}
